SuperStrict

AppTitle = "Juggle"
Global gfx_w:Int = 512
Global gfx_h:Int = 512
Graphics(gfx_w, gfx_h, 0, 60)
AutoMidHandle(True)
SeedRnd MilliSecs()
Local Frametimer:TTimer = TTimer.Create(60)

Global mx:Int, my:Int, mh1:Int, mh2:Int, md1:Int, md2:Int, ms:Float

'SetImageFont(LoadImageFont(getenv_("windir") + "/fonts/" + "courbd.ttf", 32))

SetColor(0, 0, 0)
SetClsColor(255, 255, 255)
SetBlend(ALPHABLEND)

Const GS_PLAY:Int = 0, GS_STOP:Int = 1
Global GameState:Int = GS_PLAY

Local StartTime:Int = MilliSecs()
Local Ball:TBall = TBall.Create(gfx_w *.5, 1)

Repeat
	Cls
	
	ms = MilliSecs()
	mx = MouseX()
	my = MouseY()
	mh1 = MouseHit(1)
	mh2 = MouseHit(2)
	md1 = MouseDown(1)
	md2 = MouseDown(2)
	
	Select GameState
		Case GS_PLAY
			If mh1 Then
				Ball.Poke(mx, my)
			EndIf
			Ball.Move()
			Ball.Draw()
		
			SetScale(3, 3)
			DrawText(FromatTime(MilliSecs() - StartTime), gfx_w *.5, gfx_h - 32)
			SetScale(1, 1)
			
			If Ball.check() Then
				StartTime = MilliSecs() - StartTime
				GameState = GS_STOP
			EndIf
			
		Case GS_STOP
			SetScale(3, 3)
			DrawText("GAME OVER", gfx_w *.5, gfx_h *.5 - 32)
			DrawText(FromatTime(StartTime), gfx_w *.5, gfx_h *.5 + 32)
			SetScale(1, 1)
		
	End Select
	
	
	Flip(0)
	Frametimer.Wait()
	If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
Forever
End

Type TBall
	Field x:Float, y:Float
	Field xs:Float, ys:Float
	Global grav:Float = 0.2
	Global size:Float = 48
	
	Function Create:TBall(_x:Int, _y:Int)
		Local b:TBall = New TBall
		b.x = _x
		b.y = _y
		Return b
	End Function
	
	Method Move()
		ys:+TBall.grav
		x:+xs
		y:+ys
		If x <= TBall.size Or x > (gfx_w - TBall.size) Then xs = -xs
	End Method
	
	Method Poke(_x:Float, _y:Float)
		If Distanz(x, y, _x, _y) < TBall.size Then
			ys = -8
			If _x > x Then
				xs:-.5
			ElseIf _x < x Then
				xs:+.5
			EndIf
		EndIf
	End Method
	
	Method check:Int()
		If y > gfx_h + TBall.size Then Return True
	End Method
	
	Method Draw()
		DrawKreis(x, y, TBall.size)
	End Method
	
End Type

Function FromatTime:String(_v:Int)
	Local s:String = _v / 100
	If s.Length = 1 Then s = "0" + s
	Return s[..s.length - 1] + "," + s[s.Length - 1..]
End Function

Function DrawKreis:Int(fx:Int, fy:Int, fr:Int)
	DrawOval(fx-fr, fy-fr, fr*2, fr*2)
End Function

Function Distanz:Float(sx:Float, sy:Float, zx:Float, zy:Float)
	Return Sqr(((zx - sx) ^ 2) + ((zy - sy) ^ 2))
End Function

Function DrawText(txt:String, X:Float, Y:Float, HX:Float = 0.5, HY:Float = 0.5)
	Local scale_X:Float, scale_Y:Float
	GetScale(scale_X, scale_Y)
	brl.max2d.DrawText(txt, Int(X - (Float(TextWidth(txt)) * scale_X * HX)), Int(Y - (Float(TextHeight(txt)) * scale_Y * HY)))
End Function
